<?php
/**************************************************
  Coppermine 1.5.x Plugin - TinyMCE Integration
  *************************************************
  Copyright (c) 2012 Veronica
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  *************************************************
 *
 * Plugin written by Veronica
 * 26 November 2012
 * version only for Proof-of-concept
*/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

$TINYMCE_INTEGRATION_FULLPATH = 'plugins/tinymce_integration';
global $TINYMCE_INTEGRATION_FULLPATH;

if (!defined('TINYMCE_INTEGRATION_LOG')) define('TINYMCE_INTEGRATION_LOG', 'tinymceintegration');

$thisplugin->add_action('plugin_install',                  'tinymce_integration_install');
$thisplugin->add_action('plugin_uninstall',                'tinymce_integration_uninstall');

$thisplugin->add_filter('javascript_includes',             'tinymce_integration_javascript_includes');

$thisplugin->add_filter('page_html',                       'tinymce_integration_page_html');

$thisplugin->add_filter('file_data',                       'tinymce_integration_function');
$thisplugin->add_filter('theme_display_thumbnails_params', 'tinymce_integration_function');
$thisplugin->add_filter('theme_album_params',              'tinymce_integration_function');
$thisplugin->add_filter('theme_album_params_cat',          'tinymce_integration_function');        // New hook: theme.inc 2782
$thisplugin->add_filter('theme_cat_params',                'tinymce_integration_function');        // New hook: theme.inc 2564, 2574, 2584
$thisplugin->add_filter('ecard_params',                    'tinymce_integration_function');        // New hook: ecard 225, 314
$thisplugin->add_filter('profile_form_data',               'tinymce_integration_function');        // New hook: profile 789
$thisplugin->add_filter('editpics_caption',                'tinymce_integration_function_single'); // New hook: editpics 229
$thisplugin->add_filter('register_profile6',               'tinymce_integration_function_single'); // New hook: register 486
$thisplugin->add_filter('usermgr_profile6',                'tinymce_integration_function_single'); // New hook: usermgr 994

function tinymce_integration_javascript_includes($data)
{
         global $need_tinymce, $tinymce_scripts;

         // where TinyMCE javascript is required for use in a textarea
         $tinymce_scripts = array('modifyalb.php', 'catmgr.php', 'edit_one_pic.php', 'ecard.php', 'upload.php', 'profile.php', 'editpics.php', 'register.php', 'usermgr.php');

         $superCage = Inspekt::makeSuperCage();
         $parts = explode('/', $superCage->server->getEscaped('SCRIPT_FILENAME'));

         if (in_array($parts[count($parts)-1], $tinymce_scripts)) $need_tinymce = $parts[count($parts)-1];
         elseif ($parts[count($parts)-1] == 'index.php' && GALLERY_ADMIN_MODE) $need_tinymce = 'index.php';  // TinyMCE for pluginmgr
         else $need_tinymce = false;

         if ($need_tinymce) {
            $data[] = 'tinymce/jscripts/tiny_mce/tiny_mce.js';
         }
         return $data;
}

function tinymce_integration_page_html($html)
{
         global $CONFIG, $USER_DATA, $lang_translation_info, $hdr_ip;
         global $TINYMCE_INTEGRATION_FULLPATH;
         global $viewlog_update, $tinymce_lang;
         global $need_tinymce;

         $superCage = Inspekt::makeSuperCage();

         if (!$need_tinymce) return $html;

         $TINYMCE_INTEGRATION_FULLPATH = 'plugins/tinymce_integration';

         include($TINYMCE_INTEGRATION_FULLPATH . '/setup.inc.php');

         // find out which language to load in TinyMCE
         if (array_key_exists($lang_translation_info['lang_country_code'], $tinymce_lang)) $lang_code = $tinymce_lang[$lang_translation_info['lang_country_code']];
         else $lang_code = $lang_translation_info['lang_country_code'];

         if (file_exists('tinymce/jscripts/tiny_mce/langs/' . $lang_code . '.js')) $tinymce_lang = $lang_code;
         else $tinymce_lang = 'en';

         if (!file_exists($TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt')) {
            if ($CONFIG['log_mode'] != 0) {
              if ($viewlog_update) log_write('1. No ' . $TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt for user <a href="profile.php?uid=' . USER_ID . '" rel="external" class="external">' . $USER_DATA['user_name'] . '</a> at ' . $hdr_ip, TINYMCE_INTEGRATION_LOG);
              else log_write('1. No ' . $TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt for user ' . $USER_DATA['user_name'] . ' at ' . $hdr_ip, TINYMCE_INTEGRATION_LOG);
            }
            return $html;
         }
         $tinymce_options = file_get_contents($TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt');
         if (!$tinymce_options) {
            if ($CONFIG['log_mode'] != 0) {
              if ($viewlog_update) log_write('2. No data from ' . $TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt for user <a href="profile.php?uid=' . USER_ID . '" rel="external" class="external">' . $USER_DATA['user_name'] . '</a> at ' . $hdr_ip, TINYMCE_INTEGRATION_LOG);
              else log_write('2. No data from ' . $TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt for user ' . $USER_DATA['user_name'] . ' at ' . $hdr_ip, TINYMCE_INTEGRATION_LOG);
            }
            return $html;
         }

         if(in_array($CONFIG['theme'], array('eyeball', 'hardwired'))) $skin = 'black'; else $skin = 'silver';
         $from = array('[tinymce_language_code]', '[coppermine_theme]', '[skin_variant]', '&nbsp;', '&#039;');
         $to   = array($tinymce_lang, $CONFIG['theme'], $skin, ' ', "'");
         $tinymce_options = str_replace($from, $to, strip_tags(html_entity_decode($tinymce_options, ENT_COMPAT, $CONFIG['charset'])));
         $tinymce_options = preg_replace('/(<script.*>|<\/script.*>)/Usi', '', $tinymce_options);

         if (strlen($tinymce_options) == 0) {
            if ($CONFIG['log_mode'] != 0) {
              if ($viewlog_update) log_write('3. No data usable in ' . $TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt for user <a href="profile.php?uid=' . USER_ID . '" rel="external" class="external">' . $USER_DATA['user_name'] . '</a> at ' . $hdr_ip, TINYMCE_INTEGRATION_LOG);
              else log_write('3. No data usable in ' . $TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt for user ' . $USER_DATA['user_name'] . ' at ' . $hdr_ip, TINYMCE_INTEGRATION_LOG);
            }
            return $html;
         }

         $add_js = <<< EOT

<!-- TinyMCE Integration Plugin version for proof-of-concept -->
<script type="text/javascript">
$(document).ready(function()
{
   tinyMCE.init({
{$tinymce_options}
   });
});
</script>
<!-- /TinyMCE Integration Plugin -->

</head>
EOT;
         $tinymcefmt_fix = array(
                                 'catmgr.php'       => 'rows="5" cols="40" style="width: 100%;" class="textinput',
                                 'edit_one_pic.php' => 'rows="1" cols="60" class="elastic textinput',
                                 'editpics.php'     => 'rows="1" cols="60" class="textinput elastic',
                                 'modifyalb.php'    => 'rows="5" cols="40" class="textinput',
                                 'profile.php'      => 'rows="7" cols="40" class="textinput',
                                 'register.php'     => 'rows="7" cols="60" class="textinput',
                                 'upload.php'       => 'rows="5" cols="40" class="textinput',
                                 'usermgr.php'      => 'rows="7" cols="40" class="textinput');

         $newhtml = $html;
         // add a dummy class for TinyMCE
         if (array_key_exists($need_tinymce, $tinymcefmt_fix)) {
            $newhtml = str_replace($tinymcefmt_fix[$need_tinymce] , $tinymcefmt_fix[$need_tinymce] . ' tinymcefmt', $html);
         } else {
            // strip Coppermine smilies
            if ($need_tinymce == 'ecard.php') {
               $smilie = strpos($html, 'images/smiles/lol.gif');  // remove smilies
               if ($smilie) {
                  $start    = strrpos(substr($html, 0, $smilie), '<tr>');
                  $stop1    = strpos(substr($html, $smilie), '</script>');
                  $stop2    = strpos(substr($html, $smilie+$stop1), '</tr>');
                  $new_html = substr($html, 0, $start) . substr($html, $smilie+$stop1+$stop2+5);

                  $start = strpos($new_html, '<textarea');
                  $stop  = strpos($new_html, '</textarea');

                  // Add the TinyMCE source message incl dummy class
                  if ($superCage->post->keyExists('message')) $tinymce_message = $superCage->post->getEscaped('message'); else $tinymce_message = '';
                  $newhtml  = substr($new_html, 0, $start);
                  $newhtml .= <<< EOT
                     <textarea name="message" class="textinput tinymcefmt" rows="8" cols="40" style="width: 100%;">
                       {$tinymce_message}
EOT;
                  $newhtml .= substr($new_html, $stop);
               }
            }
         }

         return str_replace('</head>', $add_js, $newhtml);
}

function decode_tinymce($str)
{
         global $CONFIG;

         if ($str == '') return $str;

         $allowedTags = '<p><strong><em><u><h1><h2><h3><h4><h5><h6><img><li><ol><ul><span><div><br><ins><del>';
         $retstr = strip_tags(html_entity_decode($str, ENT_COMPAT, $CONFIG['charset']), $allowedTags);
         // Remove all script tags
         $retstr = preg_replace('/(<script.*>|<\/script.*>)/Usi', '', $retstr);
         return $retstr;
}

function tinymce_integration_function_single($data)
{
         if (isset($data)) return decode_tinymce($data);
}

function tinymce_integration_function($data)
{
         $superCage = Inspekt::makeSuperCage();

         if (isset($data['caption']))             $data['caption']             = decode_tinymce($data['caption']);
         if (isset($data['{CAPTION}']))           $data['{CAPTION}']           = decode_tinymce($data['{CAPTION}']);
         if (isset($data['{ALB_DESC}']))          $data['{ALB_DESC}']          = decode_tinymce($data['{ALB_DESC}']);
         if (isset($data['{CAT_DESC}']))          $data['{CAT_DESC}']          = decode_tinymce($data['{CAT_DESC}']);
         // ecards
         if (isset($data['{MESSAGE}']))           $data['{MESSAGE}']           = decode_tinymce($superCage->post->getEscaped('message'));
         if (isset($data['{PLAINTEXT_MESSAGE}'])) $data['{PLAINTEXT_MESSAGE}'] = $superCage->post->getEscaped('message');
         if (isset($data['{PIC_CAPTION}']))       $data['{PIC_CAPTION}']       = decode_tinymce($data['{PIC_CAPTION}']);
         // profile
         if (isset($data['user_profile6']))       $data['user_profile6']       = decode_tinymce($data['user_profile6']);

         return $data;
}

function tinymce_integration_configure() {

         global $CONFIG, $lang_common, $lang_pluginmgr_php, $lang_admin_php, $icon_array, $lang_byte_units;
         global $lang_tinymce_integration;
         global $TINYMCE_INTEGRATION_FULLPATH;

         $superCage = Inspekt::makeSuperCage();

         $icon_array['ok']            = cpg_fetch_icon('ok', 1);
         $icon_array['help']          = cpg_fetch_icon('help', 1);
         $icon_array['reload']        = cpg_fetch_icon('reload', 1);
         $icon_array['config']        = cpg_fetch_icon('config', 1);
         $icon_array['documentation'] = cpg_fetch_icon('documentation', 1);

         list($timestamp, $form_token) = getFormToken();

         $tinymce_options = file_get_contents($TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt');

         $tinymce_options = html_entity_decode($tinymce_options, ENT_COMPAT, $CONFIG['charset']);
         $tinymce_options = str_replace('&#039;', "'", $tinymce_options);
         $tinymce_options = preg_replace('/(<script.*>|<\/script.*>)/Usi', '', $tinymce_options);

         if (file_exists($TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt')) {
            $production_created  = localised_date(filemtime($TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt'), $lang_tinymce_integration['production_created']);
            $production_created .= ', ' . filesize($TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt') . ' ' . $lang_byte_units[0];
         } else $production_created = $lang_tinymce_integration['config_no_prod'];

         if (file_exists($TINYMCE_INTEGRATION_FULLPATH . '/data/default_tinymce_options.txt')) {
            $default_created     = localised_date(filemtime($TINYMCE_INTEGRATION_FULLPATH . '/data/default_tinymce_options.txt'), $lang_tinymce_integration['default_created']);
            $default_created    .= ', ' . filesize($TINYMCE_INTEGRATION_FULLPATH . '/data/default_tinymce_options.txt') . ' ' . $lang_byte_units[0];
         } else $default_created = $lang_tinymce_integration['config_no_default'];

         if (file_exists($TINYMCE_INTEGRATION_FULLPATH . '/data/save_my_tinymce_options.txt')) {
            $copy_created        = localised_date(filemtime($TINYMCE_INTEGRATION_FULLPATH . '/data/save_my_tinymce_options.txt'), $lang_tinymce_integration['copy_created']);
            $copy_created       .= ', ' . filesize($TINYMCE_INTEGRATION_FULLPATH . '/data/save_my_tinymce_options.txt') . ' ' . $lang_byte_units[0];
         } else $copy_created = $lang_tinymce_integration['config_no_copy'];

         echo <<< EOT
    <form action="{$superCage->server->getEscaped('REQUEST_URI')}" method="post" name="tinymce_integration_configure">
        <table border="0" cellspacing="0" cellpadding="0" style="width:100%">
            <tr>
               <th class="tablef"  style="text-align:left;">
               </th>
               <th class="tablef"  style="text-align:left;">
                  {$lang_tinymce_integration['plugin_hdr_config']}
               </th>
            </tr>
            <tr>
                <td class="tableb tableb_alternate">
                </td>
                <td class="tableb tableb_alternate">
                   {$lang_tinymce_integration['plugin_help_config']}
                </td>
            </tr>
            <tr>
                <td class="tablef" style="text-align:right;">
                Current<br />TinyMCE<br />configuration<br />file
                </td>
                <td class="tablef">
                   <textarea rows="8" cols="60" name="tinymce_options" class="tinymcefmt">{$tinymce_options}</textarea>
                </td>
            </tr>
            <tr>
                <td class="tableb tableb_alternate">
                </td>
                <td class="tableb tableb_alternate">
                    {$lang_tinymce_integration['production']}
                    <button type="submit" class="admin_menu" title="{$lang_tinymce_integration['button_production_title']}" name="submit" value="{$lang_common['go']}">
                       {$icon_array['ok']} {$lang_tinymce_integration['apply_changes']}
                    </button>
                </td>
            </tr>
            <tr>
                 <td class="tablef">
                 </td>
                 <td class="tablef">
                    {$lang_tinymce_integration['backup']}
                    <button type="submit" class="admin_menu" title="{$lang_tinymce_integration['button_restore_title']}" name="restore" value="{$lang_common['go']}">
                       {$icon_array['help']} {$lang_tinymce_integration['reset_to_default']}
                    </button>
                    &nbsp;
                    <button type="submit" class="admin_menu" title="{$lang_tinymce_integration['button_save_title']}" name="save" value="{$lang_common['go']}">
                       {$icon_array['ok']} {$lang_tinymce_integration['save_my_config']}
                    </button>
EOT;
         if (file_exists($TINYMCE_INTEGRATION_FULLPATH . '/data/save_my_tinymce_options.txt')) echo <<< EOT
                    &nbsp;
                    <button type="submit" class="admin_menu" title="{$lang_tinymce_integration['button_load_title']}" name="load" value="{$lang_common['go']}">
                       {$icon_array['reload']} {$lang_tinymce_integration['load_my_config']}
                    </button>
EOT;
         echo <<< EOT
                 </td>
              </tr>
              <tr>
                  <td class="tableb tableb_alternate">
                  </td>
                  <td class="tableb tableb_alternate">
                    {$lang_tinymce_integration['documentation']}
                    <a href="http://www.tinymce.com/wiki.php/Configuration" title="{$lang_tinymce_integration['external_page']}" rel="external" class="admin_menu">
                    {$icon_array['documentation']} {$lang_tinymce_integration['configuration']}
                    </a>

                    <input type="hidden" name="form_token" value="{$form_token}" />
                    <input type="hidden" name="timestamp" value="{$timestamp}" />
                </td>
            </tr>
            <tr>
                <td class="tablef">
                </td>
                <td class="tablef">
                   {$production_created}
                </td>
            </tr>
            <tr>
                <td class="tableb tableb_alternate">
                </td>
                <td class="tableb tableb_alternate">
                   {$default_created}
                </td>
            </tr>
            <tr>
                <td class="tablef">
                </td>
                <td class="tablef">
                   {$copy_created}
                </td>
            </tr>
        </table>
    </form>
EOT;
}


function tinymce_integration_install()
{
         global $CONFIG;

         $param = 'show_bbcode_help';
         $CONFIG[$param] = 0;
         cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$param]}' WHERE name='{$param}' LIMIT 1");
         return true;
}

function tinymce_integration_uninstall()
{
         global $CONFIG;

         $param = 'show_bbcode_help';
         $CONFIG[$param] = 1;
         cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$param]}' WHERE name='{$param}' LIMIT 1");
         return true;
}

?>