<?php
/**************************************************
  Coppermine 1.5.x Plugin - TinyMCE Integration
  *************************************************
  Copyright (c) 2012 Veronica
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  *************************************************
 *
 * Plugin written by Veronica
 * 26 November 2012
 * version only for Proof-of-concept
*/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

global $lang_pluginmgr_php, $lang_translation_info, $tinymce_lang;

$TINYMCE_INTEGRATION_FULLPATH = 'plugins/tinymce_integration';
$TINYMCE_INTEGRATION_PATH = 'tinymce_integration';

include($TINYMCE_INTEGRATION_FULLPATH . '/setup.inc.php');

$icon_array['config']        = cpg_fetch_icon('config', 1);
$icon_array['announcement']  = cpg_fetch_icon('announcement', 1);
$icon_array['documentation'] = cpg_fetch_icon('documentation', 1);

$name          = $lang_tinymce_integration['plugin_name'];
$description   = $lang_tinymce_integration['plugin_description'];
$plugin_thread = 'http://forum.coppermine-gallery.net/index.php/board,91.0.html';

$author = <<< EOT
          Created by <a href="http://forum.coppermine-gallery.net/index.php?action=profile;u=19542" title="External" rel="external" class="external">Veronica</a>
EOT;

$version = 'ersion only for <u>Proof-of-concept</u>';
$plugin_cpg_version = array('min' => '2.0.0');

$announcement = <<< EOT
    <a href="{$plugin_thread}" title="External" rel="external" class="admin_menu">
       {$icon_array['announcement']} Announcement thread
    </a>
EOT;

if (!file_exists('tinymce/jscripts/tiny_mce/tiny_mce.js')) {
   $extra_info    = $lang_tinymce_integration['tinymce_config'];
   $extra_info   .= '<br />' . $lang_tinymce_integration['tinymce_config_extra'];
   //$extra_info   .= $announcement;

   $install_info  = $lang_tinymce_integration['tinymce_config'];
   $install_info .= '<br />' . $lang_tinymce_integration['install_info'];
   $install_info .= '<br />' . $lang_tinymce_integration['install_info_language'];
   //$install_info .= $announcement;

} else {

   $content = file_get_contents('tinymce/changelog.txt');
   $changelog = explode(')', $content);
   $extra_info  = $lang_tinymce_integration['tinymce_config_extra_ok'];
   if (isset($changelog[0])) $extra_info .= ' ' . $changelog[0] . ')';
   $extra_info .= '<br />' . $lang_tinymce_integration['language_description'];

   if (array_key_exists($lang_translation_info['lang_country_code'], $tinymce_lang)) $lang_code = $tinymce_lang[$lang_translation_info['lang_country_code']];
   else $lang_code = $lang_translation_info['lang_country_code'];

   if (file_exists('tinymce/jscripts/tiny_mce/langs/' . $lang_code . '.js')) $extra_info .= str_replace(array('(formal)', '(informal)', '(British)', '(US)', 'Mexican', 'Brazilian'), '', $lang_translation_info['lang_name_english']);
   else $extra_info .= 'English';

   $tinymce_hook = '';
   if (strpos(file_get_contents('include/themes.inc.php'), 'theme_cat_params')       === FALSE ||
       strpos(file_get_contents('include/themes.inc.php'), 'theme_album_params_cat') === FALSE) $tinymce_hook .= 'themes.inc, ';
   if (strpos(file_get_contents('ecard.php'),              'ecard_params')           === FALSE) $tinymce_hook .= 'ecard, ';
   if (strpos(file_get_contents('profile.php'),            'profile_form_data')      === FALSE) $tinymce_hook .= 'profile, ';
   if (strpos(file_get_contents('editpics.php'),           'editpics_caption')       === FALSE) $tinymce_hook .= 'editpics, ';
   if (strpos(file_get_contents('register.php'),           'register_profile6')      === FALSE) $tinymce_hook .= 'register, ';
   if (strpos(file_get_contents('usermgr.php'),            'usermgr_profile6')       === FALSE) $tinymce_hook .= 'usermgr, ';

   if ($tinymce_hook != '') {
      $extra_info .= $lang_tinymce_integration['tinymce_hook'] . '<br />' . substr($tinymce_hook, 0, strlen($tinymce_hook)-2) . '. See codebase for details.';
   } else {
      $extra_info .= $lang_tinymce_integration['tinymce_hook_ok'];
      $plugin_cpg_version = array('min' => '1.5.21');
   }

   $extra_info .= '<br /><b>WARNING</b> There is no rollback function for removing TinyMCE formatting when uninstalling this plugin<br />';
   //$extra_info .= $announcement . '&nbsp;';
   $install_info = $extra_info;

   if ($tinymce_hook == '') {
      $extra_info .= <<< EOT
       <a href="index.php?file={$TINYMCE_INTEGRATION_PATH}/index&amp;action=configure" class="admin_menu">
          {$icon_array['config']} {$lang_pluginmgr_php['configure_plugin']}
       </a>
EOT;

   }
}

?>