<?php
/**************************************************
  Coppermine 1.5.x Plugin - TinyMCE Integration
  *************************************************
  Copyright (c) 2012 Veronica
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  *************************************************
 *
 * Plugin written by Veronica
 * 26 November 2012
 * version only for Proof-of-concept
*/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

$TINYMCE_INTEGRATION_FULLPATH = 'plugins/tinymce_integration';

global $lang_pluginmgr_php, $lang_errors;

if (!GALLERY_ADMIN_MODE) {
    cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
}
if (!defined('PLUGINMGR_PHP')) define('PLUGINMGR_PHP', 1);

require "lang/english.php";
if ($CONFIG['lang'] != 'english' && file_exists("lang/{$CONFIG['lang']}.php")) {
   require "lang/{$CONFIG['lang']}.php";
}

include($TINYMCE_INTEGRATION_FULLPATH . '/setup.inc.php');

$message = '';
if ($superCage->post->keyExists('submit')) {
    if (!checkFormToken()) {
        cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
    }
    if ($superCage->post->keyExists("tinymce_options")) {
        $tinymce_options = str_replace('\r\n', chr(13), $superCage->post->getEscaped("tinymce_options"));
        $copy = file_put_contents($TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt', $tinymce_options);
        if ($copy) $message = $lang_tinymce_integration['config_updates_prod_ok']; else $message = $lang_tinymce_integration['config_updates_prod_err'];
    }
}
if ($superCage->post->keyExists('restore')) {
    if (!checkFormToken()) {
        cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
    }
    if (file_exists($TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt')) unlink($TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt');
    $copy = copy($TINYMCE_INTEGRATION_FULLPATH . '/data/default_tinymce_options.txt', $TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt');
    if ($copy) $message = $lang_tinymce_integration['config_default_copy_ok']; else $message = $lang_tinymce_integration['config_default_copy_err'];
}
if ($superCage->post->keyExists('save')) {
    if (!checkFormToken()) {
        cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
    }
    if (file_exists($TINYMCE_INTEGRATION_FULLPATH . '/data/save_my_tinymce_options.txt')) unlink($TINYMCE_INTEGRATION_FULLPATH . '/data/save_my_tinymce_options.txt');
    $copy = copy($TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt', $TINYMCE_INTEGRATION_FULLPATH . '/data/save_my_tinymce_options.txt');
    if ($copy) $message = $lang_tinymce_integration['config_save_copy_ok']; else $message = $lang_tinymce_integration['config_save_copy_err'];
}
if ($superCage->post->keyExists('load')) {
    if (!checkFormToken()) {
        cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
    }
    $copy = copy($TINYMCE_INTEGRATION_FULLPATH . '/data/save_my_tinymce_options.txt', $TINYMCE_INTEGRATION_FULLPATH . '/data/tinymce_options.txt');
    if ($copy) $message = $lang_tinymce_integration['config_load_copy_ok']; else $message = $lang_tinymce_integration['config_load_copy_err'];
}

$icon_array['config'] = cpg_fetch_icon('config', 1);
pageheader($lang_pluginmgr_php['configure_plugin'] . ': ' . $lang_tinymce_integration['plugin_name']);

if ($message != '') {
    if ($copy) msg_box('', $lang_tinymce_integration['config_updates'] . $message, '', '', 'success');
    else msg_box('', $lang_tinymce_integration['config_updates_error'] . $message, '', '', 'warning');
}

starttable('100%', $icon_array['config'] . $lang_pluginmgr_php['configure_plugin'] . ': ' . $lang_tinymce_integration['plugin_name']);
echo <<< EOT
    <tr>
        <td>
EOT;
tinymce_integration_configure();
echo <<< EOT
        </td>
    </tr>
EOT;
endtable();
pagefooter();
die();
?>